﻿var FWEditor = (function() {
	var version = "0.7";
	var lastupdate = "2017/09/24";
	var idcount = 0;
	var Sqsize = 16;
	var Maxwidth = 100;
	var Maxheight = 100;
	var Defaultwidth = 20;
	var Defaultheight = 20;

	var Toolpx = 20;
	var Toolpy = 20;

	var Tool_button_height = 30;
	var Toolmode = "Terrain";

	var Tool_terrain_space = 30;
	var Tool_terrain_xnum = 7;
	var Tool_building_margin = 20;
	var Tool_extra_margin = 20;

	var Tool_mode_height = 25;
	var Tool_mode_fontsize = 12;

	var Tool_country_height = 40;

	var Mode = [
		{ name: "Terrain", width: 50 },
		{ name: "Extra", width: 50 },
		{ name: "Unit", width: 50 },
//		{ name: "Map", width: 50 },
	];

	var Toolwidth = Toolpx * 2 + Tool_terrain_space * (Tool_terrain_xnum - 1) + Sqsize;
	var Toolheight = Tool_button_height + Tool_mode_height;

	var Tool_select_rectsize = Sqsize + 8;
	var Tool_select_rectcolor = "gray";
	var Tool_select = 0;
	var Tool_country_select = 0;

	var tx, ty;

	var mx, my;
	var dragx = 0;
	var dragy = 0;

	function getmyid() {
		idcount++;
		return idcount;
	}

	function Rect(x, y, w, h) {
		this.x = +x || 0;
		this.y = +y || 0;
		this.w = +w || 10;
		this.h = +h || 10;
	}
	Rect.prototype.isinside = function(x, y) {
		x = +x || 0;
		y = +y || 0;
		if (this.x <= x && x < this.x + this.w && this.y <= y && y < this.y + this.h) {
			return true;
		}
		else {
			return false;
		}
	}

	var Button = [
		{ fname: "new" },
		{ fname: "open" },
		{ fname: "save" },
	];

	var Terrain = [
		{	fname:	"plain", def: 1, land: true, receiveshadow: true },
		{	fname:	"plain_pd", def: 1, land: true, pipe: true, connect: true },
		{	fname:	"wood", def: 2, land: true, shadow: true },
		{	fname:	"mountain", def: 3, land: true, shadow: true },
		{	fname:	"road", def: 0, land: true, connect: true, receiveshadow: true },
		{	fname:	"bridge", def: 0, connect: true },
		{	fname:	"missle", def: 0, land: true, shadow: true },
		{	fname:	"sea", def: 0, sea: true, connect: true },
		{	fname:	"reef", def: 1, sea: true },
		{	fname:	"shoal", def: 0, sea: true, connect: true },
		{	fname:	"river", def: 0, land: true, connect: true },
		{	fname:	"pipe", def: 0, land: true, pipe: true, connect: true },
		{	fname:	"pipe_c", def: 0, land: true, pipe: true, connect: true, candestroy: true, hp: 99 },
		{	fname:	"misslenone", def: 0, land: true, shadow: true },
	];

	var Building = [
		{	fname:	"hq", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
		{	fname:	"city", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"base", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"airport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"seaport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"comtower", def: 3, land: true, building: true, shadow: true },
		{	fname:	"rlab", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
	]

	var Extra = [
		{	fname:	"road10", def: 0, land: true, receiveshadow: true },
		{	fname:	"road5", def: 0, land: true, receiveshadow: true },
		{	fname:	"road3", def: 0, land: true, receiveshadow: true },
		{	fname:	"road6", def: 0, land: true, receiveshadow: true },
		{	fname:	"road12", def: 0, land: true, receiveshadow: true },
		{	fname:	"road9", def: 0, land: true, receiveshadow: true, newline: true },
		{	fname:	"road7", def: 0, land: true, receiveshadow: true },
		{	fname:	"road14", def: 0, land: true, receiveshadow: true },
		{	fname:	"road13", def: 0, land: true, receiveshadow: true },
		{	fname:	"road11", def: 0, land: true, receiveshadow: true },
		{	fname:	"road15", def: 0, land: true, receiveshadow: true, newline: true },
		{	fname:	"river10", def: 0, land: true },
		{	fname:	"river5", def: 0, land: true },
		{	fname:	"river3", def: 0, land: true },
		{	fname:	"river6", def: 0, land: true },
		{	fname:	"river12", def: 0, land: true },
		{	fname:	"river9", def: 0, land: true, newline: true },
		{	fname:	"river7", def: 0, land: true },
		{	fname:	"river14", def: 0, land: true },
		{	fname:	"river13", def: 0, land: true },
		{	fname:	"river11", def: 0, land: true },
		{	fname:	"river15", def: 0, land: true, newline: true },
		{	fname:	"pipe10", land: true, pipe: true },
		{	fname:	"pipe5", land: true, pipe: true },
		{	fname:	"pipe9", land: true, pipe: true },
		{	fname:	"pipe3", land: true, pipe: true },
		{	fname:	"pipe6", land: true, pipe: true },
		{	fname:	"pipe12", land: true, pipe: true, newline: true },
		{	fname:	"pipe_cv", land: true, pipe: true, candestroy: true, hp: 99 },
		{	fname:	"pipe_ch", land: true, pipe: true, candestroy: true, hp: 99 },
		{	fname:	"plain_pdh", def: 1, land: true, pipe: true },
		{	fname:	"plain_pdv", def: 1, land: true, pipe: true, newline: true },
		{	fname:	"mcannon_l", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_u", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_r", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_d", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_all", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"bstone", land: true, candestroy: true, hp: 99, shadow: true, newline: true },
		{	fname:	"bcannon_u", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon_d", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon2", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcrystal", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, newline: true },
		{	fname:	"volcano", land: true, large: true, size: 4 },
		{	fname:	"blackarc", land: true, large: true, size: 4 },
		{	fname:	"blackarc2", sea: true, large: true, size: 4 },
		{	fname:	"largebuilding", land: true, large: true, size: 4 },
		{	fname:	"misslelauncher", land: true, large: true, size: 4 },
	]

	var Country = [ 
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
		{ fname: "no", npc: true },
	];

	var Country_indextable = [];
	for (var i = 0 ; i < Country.length ; i++) {
		var c = Country[i];
		Country_indextable[c.fname] = i;
		if (c.npc) {
			continue;
		}
		c.image = [];
		c.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
		c.image = new Image();
		c.image.src = "image/button/" + c.fname + ".png";
	}

	var Terrain_indextable = {};
	var Maptype = [
		{ fname: "normal" },
	];

	var left = 0;
	for (var b of Button) {
		b.img = new Image();
		b.img.src = "image/button/" + b.fname + ".png";
		b.rect = new Rect(left, 0, Tool_button_height, Tool_button_height);
		left += Tool_button_height;
	}

	left = 0;
	for (var m of Mode) {
		m.rect = new Rect(left, Tool_button_height, m.width, Tool_mode_height);
		left += m.width;
	}

	var shadowplainimg = [];
	var shadowroadimg = [];
	for (var k = 0 ; k < Maptype.length ; k++) {
		shadowplainimg[k] = new Image();
  	shadowplainimg[k].src = "image/terrain/" + Maptype[k].fname + "/shadowplain.png";
		shadowroadimg[k] = new Image();
  	shadowroadimg[k].src = "image/terrain/" + Maptype[k].fname + "/shadowroad.png";
	}

	for (var i = 0 ; i < Terrain.length ; i++) {
		var t = Terrain[i];
		Terrain_indextable[t.fname] = i;
		t.image = [];
		t.cimage = [];
		t.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Toolheight + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
		for (var j = 0 ; j < Maptype.length ; j++) {
			t.image[j] = new Image();
		  t.image[j].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			if (t.connect) {
				t.cimage[j] = [];
				for (var k = 0 ; k < 16 + ((t.fname == "sea") ? 8 : 0) + ((t.fname == "shoal") ? 24 : 0) ; k++) {
					t.cimage[j][k] = new Image();
				  t.cimage[j][k].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + k + ".png";
				}
			}
			if (t.fname == "plain_pd" || t.fname == "pipe_c" || t.fname == "bridge") {
				t.cimage[j] = [];
				t.cimage[j][0] = new Image();
			  t.cimage[j][0].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "h.png";
				t.cimage[j][1] = new Image();
			  t.cimage[j][1].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "v.png";
			}
			if (t.fname == "plain_pd") {
				t.cimage[j][2] = new Image();
			  t.cimage[j][2].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			}
		}
	}
	Toolheight += Toolpy + 2 * Tool_terrain_space + Tool_building_margin;
	for (var j = 0 ; j < Country.length ; j++) {
		for (var i = 0 ; i < Building.length ; i++) {
			var b = Building[i];
			if (b.hq == true && Country[j].npc) {
				continue;
			}
			var t = Terrain[Terrain.length] = {};
			t.image = [];
			var bkeys = Object.keys(b);
			for (var key in bkeys) {
				t[bkeys[key]] = b[bkeys[key]];
			}
			t.country = Country[j].fname;
			t.countryid = j;
			t.toolrect = new Rect(Toolpx + i * Tool_terrain_space, Toolheight + j * Tool_terrain_space, Sqsize, Sqsize);
			for (var k = 0 ; k < Maptype.length ; k++) {
				t.fname += "_" + Country[j].fname
				Terrain_indextable[t.fname] = Terrain.length - 1;
				t.image[k] = new Image();
		  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
			}
		}
	}
	var Extratoolindex = Terrain.length;
	var lx = 0;
	var ly = 0;
	for (var i = 0 ; i < Extra.length ; i++) {
		var e = Extra[i];
		if (lx >= Tool_terrain_xnum) {
			lx = 0;
			ly++;
		}
		var t = Terrain[Terrain.length] = {};
		var ekeys = Object.keys(e);
		for (var key in ekeys) {
			t[ekeys[key]] = e[ekeys[key]];
		}
		t.extra = true;
		t.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
		t.image = [];
		Terrain_indextable[t.fname] = Terrain.length - 1;
		for (var k = 0 ; k < Maptype.length ; k++) {
			t.image[k] = new Image();
	  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
		}
		if (t.large == true) {
			for (var y = 0 ; y < t.size ; y++) {
				for (var x = 0 ; x < t.size ; x++) {
					var t2 = Terrain[Terrain.length] = {};
					t2.image = [];
					for (var key in ekeys) {
						t2[ekeys[key]] = t[ekeys[key]];
					}
					t2.x = x;
					t2.y = y;
					t2.donotdrawtool = true;
					if (x === t2.destroyx && y === t2.destroyy) {
						t2.candestroy = true;
						t2.hp = 99;
					}
					for (var k = 0 ; k < Maptype.length ; k++) {
						t2.fname += x + "" + y;
						Terrain_indextable[t2.fname] = Terrain.length - 1;
						t2.image[k] = t.image[k];
					}
				}
			}
		}
		lx++;
		if (e.newline) {
			lx = 0;
			ly++;
			continue;
		}
	}
	Toolheight = Tool_button_height + Tool_mode_height + 9 * Tool_terrain_space + Toolpy;

	var UnitList = [
		{	fname:	"infantry" },
		{	fname:	"mech" },
	]

	var Unit_indextable = [];
	var Unit = [];
	for (var j = 0 ; j < Country.length ; j++) {
		var c = Country[j];
		if (c.npc) {
			continue;
		}
		for (var i = 0 ; i < UnitList.length ; i++) {
			var ud = UnitList[i];
			var index = Unit.length;
			var u = Unit[Unit.length] = {};
			for (var key in Object.keys(ud)) {
				u[ekeys[key]] = ud[ekeys[key]];
			}
			u.uname = u.fname;
			u.fname += "_" + c.fname;
			u.country = c.fname;
			Unit_indextable[u.fname] = index;
			u.image = [];
			u.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Tool_button_height + Tool_mode_height + Tool_country_height + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
			u.image = new Image();
		  u.image.src = "image/unit/" + u.fname + ".png";
		}
	}

	function FWEditor(canvasid) {
		var id = getmyid();

		var canvas;
		var ctx;
		var canuse;
		var map, mapbeforedrag;
		var unitdata;
		var unitmap;

		canvas = document.getElementById(canvasid);
	  if (!canvas || !canvas.getContext) {
			canuse = false;
   		return;
 		}
		canuse = true;
		ctx = canvas.getContext('2d');

		canvas.onmousemove = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			if (usetool) {
				var cx = Math.floor(mx / Sqsize);
				var cy = Math.floor(my / Sqsize);
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (evt.buttons & 1) {
						me.setmap(cx, cy, Tool_select);
					}
					else if (evt.buttons & 2) {
						var fromx = (cx < dragx) ? cx : dragx;
						var fromy = (cy < dragy) ? cy : dragy;
						var tox = (cx > dragx) ? cx : dragx;
						var toy = (cy > dragy) ? cy : dragy;
						var data = me.getdatafromtoolmode();
						var plus = (data[Tool_select].large) ? data[Tool_select].size : 1;
						me.restoremap();
						for (var x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (var y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, Tool_select);
							}
						}
					}
				}
				else if (Toolmode == "Unit") {
					if (evt.buttons & 1) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunit(cx, cy, Tool_select);
						me.setunitmap();
					}
					else if (evt.buttons & 2) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunitmap();
					}
				}
			}
			me.draw();
		}
		canvas.onmousedown = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			if (evt.buttons & 2) {
				me.backupmap();
				dragx = Math.floor(mx / Sqsize);;
				dragy = Math.floor(my / Sqsize);;
			}
			if (usetool) {
				this.onmousemove(evt);
				for (var b of Button) {
					if (b.rect.isinside(mx - tx, my - ty)) {
						if (b.fname == "new") {
							me.init();
							me.draw();
						}
						else if (b.fname == "open") {
							var input = document.createElement("input");
							input.type = "file"
							input.onchange = function(e) {
								if (this.files.length > 0){
									var f = this.files[0];
									var reader = new FileReader();
									reader.onload = (function(file) {
										var loaddata = JSON.parse(file.target.result);
										if (loaddata && loaddata.fwmapdataver) {
											width = loaddata.width;
											height = loaddata.height;
											me.init();
											map = [];
											for (var x = 0 ; x < width ; x++) {
												map[x] = [];
												for (var y = 0 ; y < height ; y++) {
													map[x][y] = Terrain_indextable[loaddata.map[x][y]];
												}
											}
											if (loaddata.unitdata !== undefined) {
												unitdata = loaddata.unitdata;
											}
											me.setunitmap();
											me.draw();
										}
										else {
											alert("ファイルの形式が違います");
										}
									});
									reader.readAsText(f);	
								}
							}
							input.click();
						}
						else if (b.fname == "save") {
							var savedata = {
								fwmapdataver:	1,	
								width: 				width,
								height:				height,
							};
							savedata.map = [];
							for (var x = 0 ; x < width ; x++) {
								savedata.map[x] = [];
								for (var y = 0 ; y < height ; y++) {
									savedata.map[x][y] = Terrain[map[x][y]].fname;
								}
							}
							savedata.unitdata = unitdata;
							var blob = new Blob([JSON.stringify(savedata, null, ' ')], {type: "application/json"});
							var a = document.createElement("a");
							a.href = URL.createObjectURL(blob);
							document.body.appendChild(a);
							a.target = "_blank";
							a.download = "save.json";
							a.click();
							document.body.removeChild(a);
						}
						break;
					}
				}
				for (var m of Mode) {
					if (m.rect.isinside(mx - tx, my - ty)) {
						Toolmode = m.name;
						Tool_select = 0;
						if (Toolmode == "Extra") {
							Tool_select = Extratoolindex;
						}
						Tool_country_select = 0;
						break;
					}
				}
				if (Toolmode == "Unit") {
					for (var i = 0 ; i < Country.length ; i++) {
						var c = Country[i];
						if (c.npc) {
							continue;
						}
						if (c.toolrect.isinside(mx - tx, my - ty)) {
							Tool_country_select = i;
							for (var j = 0 ; j < Unit.length ; j++) {
								if (Unit[Tool_select].uname == Unit[j].uname && Country[i].fname == Unit[j].country) {
									Tool_select = j;
									break;
								}
							}
							break;
						}
					}
				}
				var data = me.getdatafromtoolmode();
				for (var i = 0 ; i < data.length ; i++) {
					var t = data[i];
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					if (t.donotdrawtool != true && t.toolrect.isinside(mx - tx, my - ty)) {
						Tool_select = i;
						break;
					}
				}
			}
			me.draw();
		}
		canvas.onmouseup = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			me.draw();
		}
		canvas.addEventListener('DOMMouseScroll', mouseWheelEvent);
		canvas.onmousewheel = function(evt) {
			mouseWheelEvent(evt);
		}
		function mouseWheelEvent(evt) {
			var delta = evt.wheelDelta ? evt.wheelDelta : evt.detail;
			var data = me.getdatafromtoolmode();
			if (delta > 0) {
				while (1) {
					Tool_select++;
					if (data.length <= Tool_select) {
						Tool_select = 0;
						break;
					}
					var t = data[Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			else {
				while (1) {
					Tool_select--;
					if (Tool_select < 0) {
						Tool_select = data.length - 1;
					}
					var t = data[Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			me.draw();
		}
		canvas.onmouseout = function(evt) {
			dragflag = false;
		}
		canvas.oncontextmenu = function(evt) {
			return false;
		}
	
		var width;
		var height;
		var maptype = 0;

		var usetool = true;

		var me = this;
		
		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: width, height: height }
		};
		this.setsize = function(w, h) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			width = w;
			height = h;
			map = [];
			mapbeforedrag = [];
			for (var x = 0 ; x < width ; x++) {
				map[x] = [];
				for (var y = 0 ; y < height ; y++) {
					map[x][y] = 0;
				}
			}
		}

		this.canuse = function() {
			return canuse;
		}

		this.getdatafromtoolmode = function() {
			if (Toolmode == "Terrain" || Toolmode == "Extra") {
				return Terrain;
			}
			else {
				return Unit;
			}
		}

		this.findunit = function(x, y) {
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				for (var j = 0 ; j < unitdata[c.fname].length ; j++) {
					var u = unitdata[c.fname][j];
					if (u.x == x && u.y == y) {
						return { country: c.fname, index: j };
					}
				}
			}
			return false;
		}

		this.setunit = function(x, y, tid, check) {
			if (this.isinside(x, y)) {
				var c = Unit[tid].country;
				unitdata[c].push({ x: x, y: y, fname: Unit[tid].fname });
			}
		}	

		this.deleteunit = function(cname, index) {
			if (!unitdata[cname]) {
				return;
			}
			unitdata[cname].splice(index, 1);
		}

		this.setunitmap = function() {
			unitmap = [];
			for (var x = 0 ; x < width ; x++) {
				unitmap[x] = [];
				for (var y = 0 ; y < height ; y++) {
					unitmap[x][y] = null;
				}
			}
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				for (var j = 0 ; j < unitdata[c.fname].length ; j++) {
					var u = unitdata[c.fname][j];
					unitmap[u.x][u.y] = u.fname;
				}
			}
		}

		this.drawmap = function() {
			for (var y = 0 ; y < height ; y++) {
				for (var x = 0 ; x < width ; x++) {
					var t = Terrain[map[x][y]];
					var img;
					if (t.connect) {
						var c = 0;
						var count = 0;
						var dx = [ 0, 1, 0, -1];
						var dy = [ -1, 0, 1, 0 ];
						var di = [ 1, 3, 0, 2 ];
						var isshoal = [];
						for (var i = 0 ; i < 4 ; i++) {
							var x2 = x + dx[di[i]];
							var y2 = y + dy[di[i]];
							if (this.isinside(x2, y2)) {
								var t2 = Terrain[map[x2][y2]];
								if (t2.fname == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((t.fname == "road" && t2.fname == "road") || 
										(t.fname == "bridge" && (t2.fname == "bridge" || t2.land == true)) ||
										(t.fname == "river" && t2.fname == "river") ||
										(t.fname == "sea" && t2.land == true) ||
										(t.fname == "shoal" && t2.land == true) ||
										(t.pipe == true && t2.pipe == true && !(t.fname == "plain_pd" && t2.fname == "plain_pd"))) {
									c += Math.pow(2, di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (t.fname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = 0;
									}
									else if (c == 5) {
										c = 1;
									}
									else if (t.fname == "pipe_c") {
										map[x][y] = Terrain_indextable["pipe"];
										t = Terrain[Terrain_indextable["pipe"]];
									}
									else if (t.fname == "plain_pd") {
										c = 2;
									}
									break;
								}
							}
						}
						if (count < 2 && t.fname == "pipe_c") {
								map[x][y] = Terrain_indextable["pipe"];
								t = Terrain[Terrain_indextable["pipe"]];
						}
						if (t.fname == "plain_pd" && count != 2) {
								c = 2;
						}
						if (t.fname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = 1;
							}
							else {
								c = 0;
							}
						}
						if (t.fname == "shoal") {
							var dx = [ 1, 1, -1, -1 ];
							var dy = [ -1, 1, 1, -1 ];
							var island = [];
							for (var i = 0 ; i < 4 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							var seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (var i = 0 ; i < 4 ; i++) {
								if (c == Math.pow(2, i) && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = Terrain_indextable["sea"];
								t = Terrain[Terrain_indextable["sea"]];
							}
							else {
								for (var i = 0 ; i < 4 ; i++) {
									if (c == Math.pow(2, i)) {
										if (isshoal[(i + 3) % 4] == true && isshoal[(i + 1) % 4] == true) {
											c = 16 + i * 3;
										}
										else if (isshoal[(i + 3) % 4] == true) {
											c = 17 + i * 3;
										}
										else if (isshoal[(i + 1) % 4] == true) {
											c = 18 + i * 3;
										}
										break;
									}
									if (c == Math.pow(2, i) + Math.pow(2, (i + 1) % 4)) {
										if (isshoal[(i + 3) % 4] == true && isshoal[(i + 2) % 4] == true) {
											c = 28 + i * 3;
										}
										else if (isshoal[(i + 3) % 4] == true) {
											c = 29 + i * 3;
										}
										else if (isshoal[(i + 2) % 4] == true) {
											c = 30 + i * 3;
										}
										break;
									}
								}		
							}
						}
						if (t.fname == "sea") {
							var dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
							var dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
							var island = [];
							var isriver = [];
							for (var i = 0 ; i < 8 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								island[i] = isriver[i] = false;
								if (this.isinside(x2, y2)) {
									var t2 = Terrain[map[x2][y2]];
									if (t2.land == true) {
										island[i] = true;
									}
									if (t2.fname == "river") {
										if (i == 0 || i == 4) {
											y2 += dy[i];
											if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "river") {
												isriver[i] = true;
											}
										}
										else {
											isriver[i] = true;
										}
									}
								}
							}
							for (var i = 0 ; i < 8 ; i += 2) {
								if (isriver[i] && !isriver[(i + 7) % 8] && !isriver[(i + 1) % 8] && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
									c = 20 + i / 2;
									break;
								}
							}
						}
						img = t.cimage[maptype][c];
					}
					else {
						img = t.image[maptype];
					}
					if (t.land) {
						ctx.drawImage(Terrain[Terrain_indextable["plain"]].image[maptype], x * Sqsize, y * Sqsize);
					}
					if (t.large) {
						ctx.drawImage(img, t.x * Sqsize, t.y * Sqsize, Sqsize, Sqsize, x * Sqsize, y * Sqsize, Sqsize, Sqsize);
					}
					else {
						ctx.drawImage(img, x * Sqsize, (y + 1) * Sqsize - img.height);
					}
					if (x > 0 && t.receiveshadow && Terrain[map[x - 1][y]].shadow) {
						if (t.fname == "plain") {
							ctx.drawImage(shadowplainimg[maptype], x * Sqsize, y * Sqsize);
						}
						else {
							ctx.drawImage(shadowroadimg[maptype], x * Sqsize, y * Sqsize);
						}
					}
					if (t.fname == "sea") {
						var dx = [ [ 1, 1, -1, -1], [ 0, 1, 0, -1], [ 1, 0, -1, 0] ];
						var dy = [ [ -1, 1, 1, -1 ], [ -1, 0, 1, 0 ], [ 0, 1, 0, -1 ] ];
						var island = [];
						for (var i = 0 ; i < 4 ; i++) {
							for (var j = 0 ; j < 3 ; j++) {				
								var x2 = x + dx[j][i];
								var y2 = y + dy[j][i];
								if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
									island[j] = true;
								}
								else {
									island[j] = false;
								}
							}
							if (island[0] == true && island[1] == false && island[2] == false) {
								ctx.drawImage(t.cimage[maptype][16 + i], x * Sqsize, (y + 1) * Sqsize - img.height);
							}
						}
					}
					var uname = unitmap[x][y];
					if (uname !== null) {
						ctx.drawImage(Unit[Unit_indextable[uname]].image, x * Sqsize, y * Sqsize);
					}
				}
			}
		}

		this.copymap = function(from, to) {
			for (var x = 0 ; x < width ; x++) {
				to[x] = [];
				for (var y = 0 ; y < height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(mapbeforedrag, map);
		}
		this.backupmap = function() {
			this.copymap(map, mapbeforedrag);
		}

		this.drawtool = function() {
			for (var b of Button) {
				ctx.drawImage(b.img, tx + b.rect.x, b.rect.y);
			}
			for (var m of Mode) {
				ctx.beginPath();
				ctx.rect(tx + m.rect.x, ty + m.rect.y + 1, m.rect.w, m.rect.h);
				if (Toolmode != m.name) {
					ctx.fillStyle = "lightgray";
					ctx.fill();
				}
				ctx.strokeStyle = "black";
				ctx.lineWidth = 1;
				ctx.stroke();
				ctx.fillStyle = "black";
				ctx.font = Tool_mode_fontsize + "px sans-serif";
				var twidth = ctx.measureText(m.name).width;
				ctx.fillText(m.name, tx + m.rect.x + (m.rect.w - twidth) / 2, ty + m.rect.y + (m.rect.h + Tool_mode_fontsize) / 2);
			}

			if (Toolmode == "Unit") {
				var c = Country[Tool_country_select];
				ctx.beginPath();
				ctx.fillStyle = Tool_select_rectcolor;
				
				ctx.rect(tx + c.toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + c.toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
				ctx.fill();
				for (var i = 0 ; i < Country.length ; i++) {
					var c = Country[i];
					if (c.npc) {
						continue;
					}
					ctx.drawImage(c.image, tx + c.toolrect.x, ty + c.toolrect.y, Sqsize, Sqsize);
				}
			}

			var data = this.getdatafromtoolmode();

			ctx.beginPath();
			ctx.fillStyle = Tool_select_rectcolor;
			ctx.rect(tx + data[Tool_select].toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + data[Tool_select].toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
			ctx.fill();

			for (var i = 0 ; i < data.length ; i++) {
				var t = data[i];
				if (t.donotdrawtool) {
					continue;
				}
				if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
					continue;
				}
				if ((Toolmode == "Unit" && t.country != Country[Tool_country_select].fname)) {
					continue;
				}
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (t.land) {
						ctx.drawImage(Terrain[Terrain_indextable["plain"]].image[maptype], tx + t.toolrect.x, ty + t.toolrect.y)
					};
					if (t.large) {
						ctx.drawImage(t.image[maptype], tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
					}
					else {
						ctx.drawImage(t.image[maptype], tx + t.toolrect.x, ty + t.toolrect.y + Sqsize - t.image[maptype].height, Sqsize, t.image[maptype].height);
					}
				}
				else {
					ctx.drawImage(t.image, tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
				}
			}
		}

		this.draw = function() {
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, canvas.width, canvas.height);
			ctx.fill();
			this.drawmap();
			if (usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < width && 0 <= y && y < height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetreef = function(x, y) {
			for (var dx = -1 ; dx <= 1 ; dx++) {
				for (var dy = -1 ; dy <= 1 ; dy++) {
					if (dx == 0 && dy == 0) {
						continue;
					}
					var x2 = x + dx;
					var y2 = y + dy;
					if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
						return false;
					}
				}
			}
			return true;
		}

		this.cansetriver = function(x, y) {
			var dx = [ 0, 0, -1, -1 ];
			var dy = [-1, 0, -1, 0 ];
			for (var i = 0 ; i < 4 ; i++) {
				var x2 = x + dx[i];
				var y2 = y + dy[i];
				var allriver = true;
				for (var dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (var dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						var x3 = x2 + dx2;
						var y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || Terrain[map[x3][y3]].fname != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			if (this.isinside(x, y)) {
				for (var dx = -1 ; dx <= 1 ; dx++) {
					for (var dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						var x2 = x + dx;
						var y2 = y + dy;
						if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "reef") {
							map[x2][y2] = Terrain_indextable["sea"];
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tid) {
			var data = this.getdatafromtoolmode();
			var t = data[tid];
			if (this.isinside(x, y)) {
				var t2 = Terrain[map[x][y]];
				if (t2.large == true) {
					for (var dx = 0 ; dx < t2.size ; dx++) {
						for (var dy = 0 ; dy < t2.size ; dy++) {
							var x2 = x - t2.x + dx;
							var y2 = y - t2.y + dy;
							map[x2][y2] = Terrain_indextable["plain"];
							this.deletenearreef(x2, y2);
						}
					}
				}
				map[x][y] = tid;
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.setmap = function(x, y, tid, check) {
			check = check || false;
			retval = false;
			var t = Terrain[tid];
			if (this.isinside(x, y)) {
				if (t.fname == "pipe_c") {
					if (map[x][y] == Terrain_indextable["pipe"] && 
						((this.isinside(x - 1, y) && data[map[x - 1][y]].fname == "pipe" && this.isinside(x + 1, y) && data[map[x + 1][y]].fname == "pipe") ||
						 (this.isinside(x, y - 1) && data[map[x][y - 1]].fname == "pipe" && this.isinside(x, y + 1) && data[map[x][y + 1]].fname == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
					}
				}
				else if (t.fname == "reef") {
					if (data[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
							for (var dx = -1 ; dx <= 1 ; dx++) {
								for (var dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									var x2 = x + dx;
									var y2 = y + dy;
									if (this.isinside(x2, y2) && data[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, Terrain_indextable["sea"]);
									}
								}
							}
						}
					}
				}
				else if (t.fname == "shoal") {
					if (data[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
						}
					}
				}
				else if (t.fname == "river") {
					if (data[map[x][y]].land == true || data[map[x][y]].pipe == true) {
						if (this.cansetriver(x, y)) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
						}
					}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					if (!check) {
						for (var x2 = 0; x2 < width ; x2++) {
							for (var y2 = 0 ; y2 < height ; y2++) {
								var t2 = data[map[x2][y2]];
								if (t2.hq == true && t.country == t2.country) {
									this.changemap(x2, y2, Terrain_indextable["plain"]);
								}
							}
						}
						this.changemap(x, y, tid);
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < width && y + t.size - 1 < height) {
						retval = true;
						if (!check) {
							for (var dy = 0 ; dy < t.size ; dy++) {
								for (var dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tid + dy * t.size + dx + 1);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tid);
					}
				}
			}
			return retval;
		}

		this.init = function() {
			canvas.width = Sqsize * width;
			canvas.height = Sqsize * height;
			if (usetool) {
				canvas.width += Toolwidth;
				if (canvas.height < Toolheight) {
					canvas.height = Toolheight;
				}
			}

			unitdata = {};
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				unitdata[c.fname] = [];
			}
			this.setunitmap();

			tx = Sqsize * width;
			ty = 0;

			this.setsize(width, height);
		}

		width = Defaultwidth;
		height = Defaultheight;
		this.init(canvasid);
		this.draw();
	}
	return FWEditor;
}());
